//+------------------------------------------------------------------+
//|                                                 Level Sensor.mq4 |
//|                                          Copyright  2005, Sfen. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Sfen"
#property indicator_chart_window
#property indicator_buffers 2

// input parameters
 
extern int STEP = 20;
extern color Color= Blue ;
extern bool BARSONCHART=false; 
extern bool onethird=false;
//extern int START=100;
extern int Minutes=120;
int Period_1,n;

//
extern int MAX_HISTORY = 20;
//extern int end=0;

//----
extern string OBJECT_PREFIX = "LEVELS";
int ObjectId = 0;
       double startcount[];
       double endcount;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
     SetIndexBuffer(0,startcount);
        SetIndexBuffer(1,endcount);
  getPeriod();
  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CSH(int shift)
  {
   return (MathMax(High[shift], Low[shift]));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CSL(int shift)
  {
   return (MathMin(Low[shift],High[shift]));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string IntToStr(int X)
  {
    return (DoubleToStr(X, 0));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ObGetUniqueName(string Prefix)
  {
   ObjectId++;
   return (Prefix+" "+IntToStr(ObjectId));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()



  {
  
  /*
  if(BARSONCHART)
 {
    if (onethird==true)
   {
   int MAX_HISTORY=(WindowBarsPerChart()/3);
   }
   else
   {
    MAX_HISTORY = WindowBarsPerChart();//USED TO BE AN EXTERNAL SETTINGS OF 150 MAX.!!!!!
  }
   }
   
  else
     MAX_HISTORY = n;
     */
     if (BARSONCHART)
     {
     int START=MAX_HISTORY-3;
     }
     else
     {
     START=MAX_HISTORY;
     }
     
     int end=MAX_HISTORY-20;
  // for(int count;count=MAX_HISTORY;count<0;)
   //{
   if (Digits==2||Digits==4) STEP=STEP/10;
   
   string S;
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   double HH = 0;
   double LL = 1000000;
   int History = MathMin(Bars,MAX_HISTORY);
   int i, j, k;
   for(i = end; i < History; i++)
     {
       HH = MathMax(HH, CSH(i));
       LL = MathMin(LL, CSL(i));
     }
   int NumberOfPoints = (HH - LL) / (1.0*Point*STEP) + 1;
   int Count[];
   ArrayResize(Count, NumberOfPoints);
   for(i = 0; i < NumberOfPoints; i++) 
       Count[i] = 0;
   for(i = end; i < History; i++)
     {
       double C = CSL(i);
       while(C < CSH(i))
         {
           int Index = (C-LL) / (1.0*Point*STEP);
           
           Count[Index]++;    
           C += 1.0*Point*STEP;
           
           
           
         }
     }
   for(i = 0; i < NumberOfPoints; i++)
     {
 
       double StartX = Time[START];//5
       double StartY = LL + 1.0*Point*STEP*i;
       double EndX   = Time[START-Count[i]];//5
       double EndY   = StartY;
       string ObjName = ObGetUniqueName(OBJECT_PREFIX);
       ObjectDelete(ObjName);
       ObjectCreate(ObjName, OBJ_TREND, 0, EndX, EndY, StartX, StartY);//ObjectCreate(ObjName, OBJ_TREND, 0, StartX, StartY, EndX, EndY);
       ObjectSet(ObjName, OBJPROP_RAY, 0);
       ObjectSet(ObjName, OBJPROP_COLOR, Color);
       ObjectSet(ObjName, OBJPROP_WIDTH, 0);
       
       //THIS DOES NOT WORK YET.
       double o=START;
       double l=START+Count[i];
       double pivot= MathMax(o,l);
   


       startcount[i]=START;
       endcount=MathMax(START-(START-Count[i]),0);
      // Comment(START," - ",i);
       
       
       double bs=MathMax(StartX,EndX);
              //        Comment(START," - ",START-Count[i],"--BS: ",bs);
           ObjectCreate("buysell", OBJ_HLINE, 0, bs,0,0,0,0,0);
         ObjectSet("buysell", OBJPROP_RAY, 1);
         /////
     }
   return(0);
   //}/////
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

void getPeriod()
{
   switch(Period()) 
      {
         case 1: 
            Period_1=1; n=(Minutes/Period_1);
            break;
            
             case 5: 
            Period_1=5; n=(Minutes/Period_1);
            break;
            
             case 15: 
            Period_1=15; n=(Minutes/Period_1);
            break;
            
             case 30: 
            Period_1=30; n=(Minutes/Period_1);
            break;
            
             case 60: 
            Period_1=60; n=(Minutes/Period_1);
            break;
            
             case 240: 
            Period_1=240; n=(Minutes/Period_1);
            break;
            
             case 1440: 
            Period_1=1440; n=(Minutes/Period_1);
            break;
            
             case 10080: 
            Period_1=10080; n=(Minutes/Period_1);
            break;
            
             case 40320: 
            Period_1=40320; n=(Minutes/Period_1);
            break;
            
           
            
       }
}

